leetcode | 322. Coin Change

题目

You are given coins of different denominations and a total amount of money amount. Write a function to compute the fewest number of coins that you need to make up that amount. If that amount of money cannot be made up by any combination of the coins, return -1.

Example 1:

Input: coins = [1, 2, 5], amount = 11
Output: 3 
Explanation: 11 = 5 + 5 + 1

Example 2:

Input: coins = [2], amount = 3
Output: -1

Note:
You may assume that you have an infinite number of each kind of coin.

思路与解法

这道题目可以采用动态规划来解决,思路比较直观,定义dp[i]表示总额为i时所需的最少硬币数目。则状态转移方程为:

// j为coins切片元素的下标
if i >= coins[j] {
    dp[i] = min(dp[i], dp[i-coins[j]] + 1)
}

代码实现

const INT_MAX = int(^uint(0) >> 1)
func min(a, b int) int {
    if a < b {
        return a
    }
    return b
}
func coinChange(coins []int, amount int) int {
	dp := make([]int, amount + 1)
	for i:=1; i<=amount; i++ {
        dp[i] = INT_MAX
		for j:=0; j<len(coins); j++ {
            if i >= coins[j] && uint(dp[i-coins[j]]) < uint(INT_MAX) {
				dp[i] = min(dp[i], dp[i-coins[j]] + 1)
			}
		}
	}
    if uint(dp[amount]) >= uint(INT_MAX) {
		return -1
	}
	return dp[amount]
}

遇到的问题

由于定义的INT_MAX为int范围内的最大整数值,所以当其加1时就会造成溢出,所以在判断i>=coins[j]时增加判断uint(dp[i-coins[j]]) < uint(INT_MAX)查看dp[i-coins[j]]是否被更新为更少的硬币数目,否则不必更新dp[i]。代码最后,通过判断dp[amount]INT_MAX无符号数的数值大小即可判断是否存在一种组合。

猜你喜欢

转载自blog.csdn.net/liuyh73/article/details/84930500